'Egy BASIC mintaprogram a PICPLC1 panelre, 16F1937-re.
'A mtrixot kezel programnak a billentyk llapott soronknt kell lekrdeznie.
'Ehhez a proci egy sort alacsony szintre kapcsol, mg a msik 3 sort magas szinten tartja.
'Ezutn a mkdtet program egyms utn lekrdezi a ngy  oszlop llapott.
'                        Fontos !!!
'A programozs utn hzzuk ki a PICKIT programozt a csatlakozjbl, mert "fogja" az RB3-at!

' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.

   ANSELA = %00000000    ' porta mind digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis

'Elszr is kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
 
	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	0	' Az els adatvezetk az RD port 0. tagja. (Az RD0)
	DEFINE LCD_RSREG 	PORTD ' Az LCD Register Select kivezetse a D portra csatlakozik,
	DEFINE LCD_RSBIT 	4	' mgpedig az RD4 labra. (Tehat az LCD RS - az RD4 porton van.)
	DEFINE LCD_EREG 	PORTD ' Az enable vezerl bit is a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva. (LCD EN - RD5 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD
	
' lltsuk be, melyik port legyen kimenet, s melyik bemenet:
	
	TRISA = %00001111	' A PORTA0-3 input, a PORTA 4-7 output
	TRISB = %00001111	' A PORTB0-3 input, 4-7 output
	TRISE = %00000000	' A PORTE.0 s PORTE.1, PORTE.2 output
	TRISC = %00111100	' A PORTC 2-5 input, a PORTC 0-1 s 6-7 output
    OPTION_REG.7 = 0   	' Engedlyezzk a PORTB bels felhz ellenllsait
    WPUB = %11111111    ' Az sszeset
    
	BEMENET VAR PORTA.0
	K1GOMB var PORTC.2			' A K4 nyomgomb a PORTC 2-n van,
	
	OSZLOP1 var PORTB.3
	OSZLOP2 var PORTB.2
	OSZLOP3 var PORTB.1
	OSZLOP4 var PORTB.0
	SOR1 var PORTB.4
	SOR2 var PORTB.5
	SOR3 var PORTE.0
	SOR4 var PORTE.1
    
		' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban
		
   	LCDFRISS var BIT ' Egy jelz bit. Azt jelzi, hogy frissteni kell az LCD-n a kirst
    GOMB Var Byte    ' Ebben lesz majd a megnyomott gomb rtke     
    LCDFRISS = 1     ' Bekapcsols utn mindjrt rjunk is az LCD-re
   
main:       

    GOMB = $FF
    
    SOR1 = 0 : SOR2 = 1 : SOR3 = 1 : SOR4 = 1
    IF OSZLOP1 = 0 THEN GOMB = 1
    IF OSZLOP2 = 0 THEN GOMB = 2
    IF OSZLOP3 = 0 THEN GOMB = 3
    IF OSZLOP4 = 0 THEN GOMB = 4
 
    SOR1 = 1 : SOR2 = 0 : SOR3 = 1 : SOR4 = 1
    IF OSZLOP1 = 0 THEN GOMB = 5
    IF OSZLOP2 = 0 THEN GOMB = 6
    IF OSZLOP3 = 0 THEN GOMB = 7
    IF OSZLOP4 = 0 THEN GOMB = 8
    SOR1 = 1 : SOR2 = 1 : SOR3 = 0 : SOR4 = 1

    IF OSZLOP1 = 0 THEN GOMB = 9
    IF OSZLOP2 = 0 THEN GOMB = 10
    IF OSZLOP3 = 0 THEN GOMB = 11
    IF OSZLOP4 = 0 THEN GOMB = 12
    SOR1 = 1 : SOR2 = 1 : SOR3 = 1 : SOR4 = 0

    IF OSZLOP1 = 0 THEN GOMB = 13
    IF OSZLOP2 = 0 THEN GOMB = 14
    IF OSZLOP3 = 0 THEN GOMB = 15
    IF OSZLOP4 = 0 THEN GOMB = 16

    IF GOMB != $FF THEN 
        LCDFRISS = 1 
        SOUND PORTE.2,[100,20,80,20] 
    endif    
         
    If LCDFRISS = 1 THEN
	       LCDOUT $fe,$80,"Gomb: ",dec2 GOMB	' irs az els sorba
	       LCDFRISS = 0  'Kirtuk amit kell, a jelz bitet alaphelyzetbe lltjuk                        
    endif 
	      
    goto main		' Ugras a ciklus elejere, kezdodik minden ujra... 

    END				' Itt a progi vege. 
